/**
 * @file	formulation.h
 *
 * @author	Francois Clad
 * @date	2012-06-21
 * @version	0.1
 */

#ifndef _FORMULATION_H_
#define _FORMULATION_H_

/* Standard C libraries */
#include <stdio.h>
#include <stdlib.h>

/* GNU GLPK solver */
#include <glpk.h>

#include "base.h"
#include "topology.h"
#include "traces.h"

#define INITIAL_MATRIX_CAPACITY 1024


typedef struct _lp_matrix lp_matrix;


glp_prob	*lp_generate_problem	(Topology *topo);

void		lp_print_result			(glp_prob *, FILE *, uint);
void		lp_solve_problem		(glp_prob *prob);
void		lp_free_problem			(glp_prob *prob);

void		lp_free_matrix			(lp_matrix *);



#endif // _FORMULATION_H_

