#ifndef HASHTABLE_H
#define HASHTABLE_H

#include <string.h>
#include <stdlib.h>

#include "base.h"

typedef struct entry_s
{
	char*	key;
	uint	value;
	struct entry_s* next;
} entry;

typedef struct
{
	unsigned int length;
	entry** table;
	unsigned int counter;
} hashtable;


hashtable* create_table (unsigned int size);

int insert_value (hashtable* htab, char* key, uint value);

uint search_value (hashtable* htab, char* key);

uint remove_value (hashtable* htab, char* key);

int count_values (hashtable* htab);

void destroy_table (hashtable* htab);

unsigned long hash (char* str);

#endif
