/**
 * @file	uintll.c
 *
 * @author	Francois Clad
 * @date	2012-03-12
 * @version	1.1
 */

#include "uintll.h"



/*************
 * Functions * 
 *************/


uintll *newUintll (unsigned int value, uintll *next) {
	uintll *el = NULL;

	if ((el = (uintll *)malloc(sizeof(uintll))) == NULL)
		errExit("malloc");

	el->value = value;
	el->next = next;

	return el;
}

uintll *addUintll (unsigned int value, uintll *el) {
	if (el == NULL)
		return newUintll(value, NULL);

	if (el->value != value)
		el->next = addUintll(value, el->next);

	return el;
}

uintll *delHead (uintll *head) {
	uintll *newHead = NULL;

	if (head == NULL)
		return NULL;

	newHead = head->next;
	free(head);
	return newHead;
}

unsigned int sizeUintll (uintll *el) {
	if (el == NULL)
		return 0;

	return 1 + sizeUintll(el->next);
}

void freeUintll (uintll *el) {
	if (el == NULL)
		return;

	freeUintll(el->next);
	free(el);
}

uintll *copyUintll (uintll *el) {
	if (el == NULL)
		return NULL;

	return newUintll(el->value, copyUintll(el->next));
}

uintll *searchUintll (uintll *el, uint val) {
	if (el == NULL || el->value == val)
		return el;

	return searchUintll(el->next, val);
}

void printUintll (uintll *el, FILE *file) {
	if (el == NULL)
		return;

	fprintf(file, "%u ", el->value);
	printUintll(el->next, file);
}

