/**
 * @file	traces.h
 *
 * @author	Francois Clad
 * @date	2012-07-27
 * @version	0.1
 */

#ifndef _TRACES_H_
#define _TRACES_H_

/* Standard C libraries */
#include <stdio.h>
#include <stdlib.h>
#include <regex.h>

#include "base.h"
#include "topology.h"
#include "hashtable.h"
#include "uintll.h"


typedef struct _pathll Pathll;

struct _pathll {
	uintll	*path;
	Pathll	*next;
};



void		importTraces	(Topology *, hashtable *, char *);
void		importTraces2	(Topology *, hashtable *, char *);

Pathll		*get_chosen_paths	(Node *, uint, uint);
Pathll		*get_alt_paths		(Topology *, Pathll *, uint, uint);

/**
 * @brief	Recursively de-allocate a path list (and all its elements)
 *
 * @param	pl		Pointer to the list head
 */
void		freePathll		(Pathll *);

void		printPaths		(Topology *, Pathll *, Pathll *, char *);

#endif // _TRACES_H_

