"""
@file		exportGraph.py

@author		Francois Clad
@date		2012-06-25
@version	1.0
"""

import sys, os, pickle
import networkx as nx

def printGraph (infile, outfile = ''):
	G = pickle.load(open(infile))

	H = nx.Graph()

	for e in G.edges():
		if e[0] != e[1]:
			H.add_edge(*e)

	if outfile == '':
		outfile = os.path.splitext(infile)[0] + '.gv'
	
	nx.write_dot(nx.connected_component_subgraphs(H)[0], outfile)

	return True


if __name__ == "__main__":
	if sys.argv >= 3 and printGraph(sys.argv[1], sys.argv[2]):
		sys.exit(0)
	sys.exit(1)

